#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "dpu2commandqueue4xi5test.py">
#<abstract4xi abstract = "tests commandqueue4dpu.py"/>
#<verify4xi verification = "11" target = "dpu2commandqueue4xi.py"/>
#<contextualize4xi context = "commandqueue4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = ['dpu2commandqueue4xi5test']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pipe4xi import Pipe4Xi   
from platformids4xi import get2platformids4xi
from queue4xi import Queue4Xi

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from dpu2commandqueue4xi import DPU2CommandQueue4Xi
from dpu2commandqueue4xi import create2commandqueue4dpu 
from dpu2commandqueue4xi import flush2commandqueue4dpu
from dpu2commandqueue4xi import finish2commandqueue4dpu
from dpu2commandqueue4xi import get2commandqueueinfo4dpu
from dpu2commandqueue4xi import release2commandqueue4dpu
from dpu2commandqueue4xi import retain2commandqueue4dpu
from dpu2commandqueue4xi import set2commandqueue4dpu
from dpu2commandqueue4xi import trace2commandqueue4dpu



# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from dpu2context4xi import DPU2Context4Xi 
from dpu2context4xi import create2context4dpu
from dpu2context4xi import get2context4dpu
from dpu2context4xi import release2context4dpu
from dpu2context4xi import retain2context4dpu
from dpu2context4xi import set2context4dpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from dpu2device4xi import DPU4Xi
from dpu2device4xi import init2dpu4xi 
from dpu2device4xi import set2dpu4xi
from dpu2device4xi import get2dpu4xi


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi

# -------------------------------------------------------------------------------------------------
# Trace modules                    
# -------------------------------------------------------------------------------------------------

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
from print4xi import print4xi                                                                                     # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 

    
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'CommandQueue4DPU': 'NACK4TRACE',
         'create2commandqueue4dpu': 'NACK4TRACE',
         'get2commandqueueinfo4dpu': 'NACK4TRACE',
         'release2commandqueue4dpu': 'NACK4TRACE',
         'retain2commandqueue4dpu': 'NACK4TRACE',
         'set2commandqueue4dpu': 'NACK4TRACE'
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>                  

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   print XML trace for commandqueue4dpu test
#"> 

# -------------------------------------------------------------------------------------------------    
def print2trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-dpu2commandqueue4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdpuxi.org/sw4xi/python33/owl/multiprocessing4dpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing CommandQueue of DPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">CommandQueue of DPU sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-dpu2commandqueue4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdpuxi.org/sw4xi/python33/owl/multiprocessing4dpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for CommandQueue of DPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-dpu2commandqueue4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdpuxi.org/sw4xi/python33/owl/multiprocessing4dpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for CommandQueue of DPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of CommandQueue of DPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "dpu2commandqueue4xi5test" usage = "
#   tests commandqueue4dpu
#"> 

# -------------------------------------------------------------------------------------------------    
def dpu2commandqueue4xi5test():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
    
        # ---------------------------------------------------------------------------------------------
        # START                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 1A/33) OF DPU2COMMANDQUEUE4XI5TEST - STARTED ', time4xi()) 
        print('=' *33)   
        # 
        
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS                           
        # ---------------------------------------------------------------------------------------------
        
                  
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - CREATE COMMANDQUEUE WITH FUNCTION                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 2A/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO CREATE COMMANDQUEUE4DPU ', time4xi())     
        print('=' *33)        
        # 
        
        try:
            cq2dpu = create2commandqueue4dpu()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
            print('(Step 2B/33) OF DPU2COMMANDQUEUE4XI5TEST - CREATED COMMANDQUEUE4DPU: ', cq2dpu)                                  
            # 
            
        except:
            print('(Step 2Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO CREATE COMMANDQUEUE4DPU', time4xi()) 
    
                  
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - FLUSH COMMANDQUEUE WITH FUNCTION                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 2B1/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO FLUSH COMMANDQUEUE4DPU ', time4xi())        
        print('=' *33)        
        #  
    
        task4flush2commandqueue = cq2dpu
        try:
            flush2dpu = flush2commandqueue4dpu(task4flush2commandqueue)                                                     
            print('(Step 2B2/33) OF DPU2COMMANDQUEUE4XI5TEST - FLUSHED COMMANDQUEUE4DPU: ', flush2dpu)                                  
            # 
        except:
            print('(Step 2BZ/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO FLUSH COMMANDQUEUE4DPU', time4xi())         
     
                  
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - FINISH COMMANDQUEUE WITH FUNCTION                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 2B2/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO FINISH COMMANDQUEUE4DPU ', time4xi())      
        print('=' *33)        
        #   
    
        task4finish2commandqueue = cq2dpu
        try:
            finish2dpu = finish2commandqueue4dpu(task4finish2commandqueue)                                                     
            print('(Step 2B2/33) OF DPU2COMMANDQUEUE4XI5TEST - FINISHED COMMANDQUEUE4DPU: ', finish2dpu)                                   
            # 
        except:
            print('(Step 2BZ/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO FINISH COMMANDQUEUE4DPU', time4xi())        
                       
                        
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - GET COMMANDQUEUE INFO               
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 3A/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO GET COMMANDQUEUEINFO4DPU', time4xi())  
        print('=' *33)    
        try:
            cqinfo2dpu = get2commandqueueinfo4dpu()                                                                       # AFTER SYSTEM CREATED  
            print('(Step 3B/33) OF DPU2COMMANDQUEUE4XI5TEST - GOT COMMANDQUEUEINFO4DPU: ', cqinfo2dpu) 
            # 
            
        except:
            print('(Step 3Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO GET COMMANDQUEUE4DPU', time4xi())
                
        
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - SET COMMANDQUEUEINFO WITH FUNCTION - ALL ATTRIBUTES                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 4A/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO SET COMMANDQUEUEINFO WITH FUNCTION ', time4xi())    
        print('=' *33)
        
        # ---------------------------------------------------------------------------------------------
        # (1) GET PLATFORM IDs TO SET CONTEXT
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 4B/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
        print('=' *33)    
        platform2xi = {}
        try:
            platform2xi = get2platformids4xi()
            print('(Step 4B/33) of CONTEXT4DPU5TEST - GOT PLATFORMIDS4XI', platform2xi) 
            # 
             
        except:
            print('(Step 4Z/33) of CONTEXT4DPU5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
    
        # ---------------------------------------------------------------------------------------------
        # (2) INITIALIZE DEVICE                       
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 2A/33) OF DEVICE4DPU5TEST - TRYING TO INITIALIZE DEVICE4DPU ', time4xi())   
        print('=' *33)        
        try:
            device2dpu = init2dpu4xi()                                                                                # NO PARAMETERS - THE SYSTEM SHOULD INITIALIZE
            print('(Step 2B/33) OF DEVICE4DPU5TEST - INITIALIZED DEVICE4DPU TO: ', device2dpu)        
            # 
            
        except:
            print('(Step 2Z/33) OF DEVICE4DPU5TEST *** FAILED TO INITIALIZE DEVICE4DPU', time4xi()) 
                
            
        # ---------------------------------------------------------------------------------------------
        # (3) CREATE CONTEXT                  
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 3A/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO CREATE CONTEXT4DPU ', time4xi())    
        print('=' *33)        
        try:
            context2dpu = create2context4dpu()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
            print('(Step 3B/33) OF DPU2COMMANDQUEUE4XI5TEST - CREATED CONTEXT4DPU: ', context2dpu)                                  
            # 
            
        except:
            print('(Step 3Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO CREATE CONTEXT4DPU', time4xi()) 
         
    
              
        # ---------------------------------------------------------------------------------------------
        # (4) INITIALIZE TASK DICTIONARY                         
        # ---------------------------------------------------------------------------------------------            
        task4create2commandqueue = {}
    
        
        # ---------------------------------------------------------------------------------------------
        # (5) DEFINE CONTEXT                           
        # ---------------------------------------------------------------------------------------------         
        task4create2commandqueue  ['CONTEXT'] = context2dpu  
    
        
        # ---------------------------------------------------------------------------------------------
        # (6) DEFINE DEVICE                           
        # ---------------------------------------------------------------------------------------------         
        task4create2commandqueue  ['DEVICE'] = device2dpu  
    
        # ---------------------------------------------------------------------------------------------
        # (7) DEFINE PROPERTIES                           
        # ---------------------------------------------------------------------------------------------         
        task4create2commandqueue  ['PROPERTIES'] = None 
    
        
        # ---------------------------------------------------------------------------------------------
        # (8) DEFINE ERROR CODE                           
        # ---------------------------------------------------------------------------------------------         
        task4create2commandqueue  ['CODE2ERROR'] = 0 
    
           
        response4create2commandqueue = {} 
        print('(Step 4B/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO GET RESPONSE FOR CREATE2COMMANDQUEUE4DPU ', time4xi())   
        try:                               
            response4create2commandqueue = create2commandqueue4dpu(task4create2commandqueue)                                                     # ALL ATTRIBUTES SET                                                        
            print('(Step 4C/33) OF DPU2COMMANDQUEUE4XI5TEST - RESPONSE4SET2COMMANDQUEUE : ', response4create2commandqueue)                           
            # 
            
        except:
            print('(Step 4Z1/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO GET RESPONSE FOR CREATE2COMMANDQUEUE4DPU ', time4xi())  
            
        
        # ---------------------------------------------------------------------------------------------
        # (9) REFERENCE COUNT FOR EACH PROCESSING UNIT RELEASED BY DECREMENTING COUNT WITH 1             
        # ---------------------------------------------------------------------------------------------    
    
        task4release2commandqueue  = {} 
                                                    
        task4release2commandqueue  ['COUNT2REFERENCE'] = 1 
        
        response4release2commandqueue = {}
        
        print('(Step 5A/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO RELEASE COMMANDQUEUE OF EACH DEVICE ', time4xi())   
        try:                               
            response4release2commandqueue = release2commandqueue4dpu(task4release2commandqueue)                                         # COUNT2REFERENCE                                                      
            print('(Step 5BD/33) OF DPU2COMMANDQUEUE4XI5TEST - RESPONSE4RELEASE2COMMANDQUEUE : ', response4release2commandqueue)                           
            # 
            
        except:
            print('(Step 5Z1/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO RELEASE COMMANDQUEUE OF EACH DEVICE ', time4xi())  
                    
        
        # ---------------------------------------------------------------------------------------------
        # (10) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAINED BY INCREMENTING COUNT WITH 1             
        # ---------------------------------------------------------------------------------------------    
    
        task4retain2commandqueue  = {} 
                                                        
        task4retain2commandqueue  ['COUNT2REFERENCE'] = 1 
     
        
        response4retain2commandqueue = {}
        
        print('(Step 6A/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO RETAIN COMMANDQUEUE OF EACH DEVICE ', time4xi())  
        try:                               
            response4retain2commandqueue = retain2commandqueue4dpu(task4retain2commandqueue)                                 # COUNT2REFERENCE                                                      
            print('(Step 6BD/33) OF DPU2COMMANDQUEUE4XI5TEST - RESPONSE4RELEASE2COMMANDQUEUE : ', response4retain2commandqueue)                          
            # 
            
        except:
            print('(Step 6Z1/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO RETAIN COMMANDQUEUE OF EACH DEVICE ', time4xi())  
    
            
                                               
       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS                          
        # ---------------------------------------------------------------------------------------------
        print('=' *33)          
        print('(Step 5A/33) OF DPU2COMMANDQUEUE4XI5TEST - CREATING COMMANDQUEUE4DPU OBJECT', time4xi())   
        print('=' *33)  
        try:
            # ---------------------------------------------------------------------------------------------
            # CREATE WITH OBJECT                        
            # ---------------------------------------------------------------------------------------------        
            cc2dpu = DPU2CommandQueue4Xi()
            print('(Step 5B/33) OF DPU2COMMANDQUEUE4XI5TEST - CREATED COMMANDQUEUE4DPU OBJECT: ', cc2dpu)                                  
            # 
            
        except:
            print('(Step 5Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO CREATE COMMANDQUEUE4DPU OBJECT')
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - GET METHOD                  
        # ---------------------------------------------------------------------------------------------          
        print('(Step 6A/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO GET COMMANDQUEUE INFO')  
        try:                               
            info4dpu = cc2dpu.get2dpu()                                  
            print('(Step 6B/33) OF DPU2COMMANDQUEUE4XI5TEST - GOT COMMANDQUEUE INFO: ', info4dpu)                                            
            # 
             
        except:
            print('(Step 6Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO GET COMMANDQUEUE INFO')   
         
        
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SET METHOD            
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 7A/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO SET COMMANDQUEUE ', time4xi())
        print('=' *33)       
    
              
        # ---------------------------------------------------------------------------------------------
        # (4) INITIALIZE TASK DICTIONARY                         
        # ---------------------------------------------------------------------------------------------            
        task4set2commandqueue = {}
    
    
        # ---------------------------------------------------------------------------------------------
        # (5) DEFINE CONTEXT                           
        # ---------------------------------------------------------------------------------------------         
    
        task4set2commandqueue  ['CONTEXT'] = context2dpu  
    
        
        # ---------------------------------------------------------------------------------------------
        # (6) DEFINE DEVICE                           
        # ---------------------------------------------------------------------------------------------         
    
        task4set2commandqueue  ['DEVICE'] = device2dpu  
                          
            
        # ---------------------------------------------------------------------------------------------
        # (7) DEFINE PROPERTIES                           
        # ---------------------------------------------------------------------------------------------         
        MODE2EXECUTE = 'IN2ORDER'
        PERMISSION2PROFILE = 'ENABLE'
            
        task4set2commandqueue  ['PROPERTIES'] = {}
    
        task4set2commandqueue  ['PROPERTIES'] ['EXECUTION'] =  MODE2EXECUTE
    
        task4set2commandqueue  ['PROPERTIES'] ['PROFILING'] =  PERMISSION2PROFILE
    
        
        # ---------------------------------------------------------------------------------------------
        # (8) DEFINE ERROR CODE                           
        # ---------------------------------------------------------------------------------------------         
        task4set2commandqueue  ['CODE2ERROR'] = 0 
    
        
        # ---------------------------------------------------------------------------------------------
        # (9) QUEUE                           
        # ---------------------------------------------------------------------------------------------         
        task4set2commandqueue  ['QUEUE'] = None
        try:
            task4set2commandqueue  ['QUEUE'] = Queue4Xi() 
            print('(Step 7B/33) OF DPU2COMMANDQUEUE4XI5TEST - QUEUE : ', task4set2commandqueue  ['QUEUE']) 
            # 
        except:
            print('(Step 7Z1/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO CREATE QUEUE4XI ', time4xi()) 
                
        # ---------------------------------------------------------------------------------------------
        # (10) PIPE                           
        # ---------------------------------------------------------------------------------------------         
        task4set2commandqueue  ['PIPE'] = None
        try:
            task4set2commandqueue  ['PIPE'] = Pipe4Xi() 
            print('(Step 7C/33) OF DPU2COMMANDQUEUE4XI5TEST - PIPE : ', task4set2commandqueue  ['PIPE'])
            # 
        except:
            print('(Step 7Z2/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO CREATE PIPE4XI ', time4xi()) 
                
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SET COMMANDQUEUE WITH METHOD                  
        # ---------------------------------------------------------------------------------------------     
        print('(Step 7D/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO CALL SET2DPU METHOD: ', time4xi())      
        try: 
            response4set2commandqueue = cc2dpu.set2dpu(task4set2commandqueue)                                                       
            print('(Step 7E/33) OF DPU2COMMANDQUEUE4XI5TEST - RESPONSE4SET2COMMANDQUEUE : ', response4set2commandqueue) 
            # 
            
        except:
            print('(Step 7Z3/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO SET COMMANDQUEUE ', time4xi())   
            
    
                                                                                     
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - FLUSH COMMANDQUEUE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 8A/33) OF DPU2COMMANDQUEUE4XI5TEST - FLUSHING ', time4xi()) 
        print('=' *33)      
      
        try:
            flush2xi = cc2dpu.flush2dpu()
        
            print('=' *33)          
            print('(Step 8B/33) OF DPU2COMMANDQUEUE4XI5TEST - FLUSHED: ', flush2xi)    
            # 
            
        except:
            print('(Step 8Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO FLUSH ', time4xi()) 
    
                                                                                     
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - FINISH COMMANDQUEUE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 9A/33) OF DPU2COMMANDQUEUE4XI5TEST - FINISHING ', time4xi()) 
        print('=' *33)      
        
        try:
            finish2xi = cc2dpu.finish2dpu()
        
            print('=' *33)          
            print('(Step 9B/33) OF DPU2COMMANDQUEUE4XI5TEST - FINISHED: ', finish2xi)   
            # 
            
        except:
            print('(Step 9Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO FINISH ', time4xi())         
     
                    
                                                                                     
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RELEASE COMMANDQUEUE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 21A/33) OF DPU2COMMANDQUEUE4XI5TEST - RELEASING ', time4xi()) 
        print('=' *33)      
        
        task4release2commandqueue  = {}
        task4release2commandqueue  ['COUNT2REFERENCE'] = 1
    
        
        try:
            release2xi = cc2dpu.release2dpu(task4release2commandqueue)
        
            print('=' *33)          
            print('(Step 21B/33) OF DPU2COMMANDQUEUE4XI5TEST - RELEASED: ', release2xi)   
            # 
            print('=' *33)
        except:
            print('(Step 21Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO RELEASE ', time4xi()) 
            
                                                                                       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RETAIN COMMANDQUEUE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 22A/33) OF DPU2COMMANDQUEUE4XI5TEST - RETAIN ', time4xi())
        print('=' *33)      
    
        task4retain2commandqueue  = {}
        task4retain2commandqueue  ['COUNT2REFERENCE'] = 1
       
        
        try:
            
            retain2xi = cc2dpu.retain2dpu(task4retain2commandqueue)
        
            print('=' *33)          
            print('(Step 22B/33) OF DPU2COMMANDQUEUE4XI5TEST - RETAINED: ', retain2xi) 
            # 
            
            print('=' *33)
        except:
            print('(Step 22Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO RETAIN ', time4xi()) 
                       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - CREATE COMMANDQUEUE                           
        # ---------------------------------------------------------------------------------------------        
        print('(Step 23A/33) OF DPU2COMMANDQUEUE4XI5TEST - TRYING TO CREATE DPU COMMANDQUEUE', time4xi()) 
        # 
        try:
            cc2xi = DPU2CommandQueue4Xi()                            
            commandqueue2dpu = cc2xi.create2dpu()                                  
            print('(Step 23B/33) OF DPU2COMMANDQUEUE4XI5TEST - CREATED DPU COMMANDQUEUE: ', commandqueue2dpu)
            # 
                                                      
        except:
            print('(Step 23Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO CREATE DPU COMMANDQUEUE ***', time4xi())                  
                                                                                               
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SENSE COMMANDQUEUE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 24A/33) OF DPU2COMMANDQUEUE4XI5TEST - SENSING ', time4xi())  
        print('=' *33)      
        
        try:
            print(cc2dpu.sense())
        
            print('=' *33)          
            print('(Step 24B/33) OF DPU2COMMANDQUEUE4XI5TEST - SENSED ', time4xi()) 
            # 
            print('=' *33)
        except:
            print('(Step 24Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO SENSE ', time4xi())          
            
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - REASON COMMANDQUEUE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 25A/33) OF DPU2COMMANDQUEUE4XI5TEST - REASONING ', time4xi())
        print('=' *33)       
        
        try:
            print(cc2dpu.reason())
        
            print('=' *33)          
            print('(Step 25B/33) OF DPU2COMMANDQUEUE4XI5TEST - REASONED ', time4xi())
            # 
            
            print('=' *33)       
        except:
            print('(Step 25Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO REASON ', time4xi())                                   
                 
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - ACE COMMANDQUEUE                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 26A/33) OF DPU2COMMANDQUEUE4XI5TEST - ACING ', time4xi())   
        print('=' *33)       
        
        try:
            print(cc2dpu.ace())
        
            print('=' *33)          
            print('(Step 26B/33) OF DPU2COMMANDQUEUE4XI5TEST - ACED ', time4xi())                                                 
            # 
            
            print('=' *33) 
        except:
            print('(Step 26Z/33) OF DPU2COMMANDQUEUE4XI5TEST *** FAILED TO ACE ', time4xi())                                       
         
        # ---------------------------------------------------------------------------------------------
        # DONE - ALL TESTS                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 33/33) OF DPU2COMMANDQUEUE4XI5TEST - DONE! ', time4xi())
        #                                         
        print('=' *33) 
        
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace - whatever happened
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(t2xi)    
      
#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for dpu2commandqueue4xi5test
#"> 

# -------------------------------------------------------------------------------------------------    
def main():
       
    print('=' *33)
    print("(Step 0A/33) OF DPU2COMMANDQUEUE4XI5TEST - SENSING IT WITH YOURDPUXI!", time4xi())  
    # 
    print('=' *33)
        
    dpu2commandqueue4xi5test()  
    
    print('=' *33)
    print("(Step 0B/33) OF DPU2COMMANDQUEUE4XI5TEST - SENSED IT WITH YOURDPUXI!", time4xi()) 
    # 
       
    print('=' *33) 
                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   dpu2commandqueue4xi5test.txt
#   sense-dpu2commandqueue4xi5test.xml
#   reason-dpu2commandqueue4xi5test.xml
#   ace-dpu2commandqueue4xi5test.xml
#" 
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of dpu2commandqueue4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
